from django.http import HttpResponse, Http404
from rest_framework.views import APIView
from rest_framework.response import Response
from rest_framework import status
from rest_framework.pagination import LimitOffsetPagination, PageNumberPagination
from .serializers import SciamImageSerializer
from django.shortcuts import render
from .models import SciamImage
from .enums import SUBJECTS, YEARS, TOPICS, TOPICS_STR, SEARCH_TYPES, SEARCH_TYPES_STR


class SciamImageList(APIView):
    def get(self, request, format=None):
        sciamimages = SciamImage.objects.all()
        serializer = SciamImageSerializer(sciamimages, many=True)
        return Response(serializer.data)

    def post(self, request, format=None):
        ############## BROWSE ############
        if request['type'] == 'search':  # browse
            all_image_data = SciamImage.objects.all()
            selected_year = request.POST['year']
            selected_subject = request.POST['subject']
            if selected_year != 'null':
                all_imgs = SciamImage.objects.filter(date__year=selected_year)
            if selected_subject != 'null':
                if 'all_imgs' in locals():
                    all_imgs = all_imgs.filter(subject=selected_subject)
                else:
                    all_imgs = SciamImage.objects.filter(
                        subject=selected_subject)
            if 'all_imgs' in locals():
                serializer = SciamImageSerializer(all_imgs, many=True)
                return Response({"year": request.POST['year'], "subject": request.POST['subject'], "data": serializer.data})
            else:
                serializer = SciamImageSerializer(all_image_data, many=True)
                return Response({"year": request.POST['year'], "subject": request.POST['subject'], "data": serializer.data})
        ############# SEARCH #############
        elif request['type'] == 'search':  # search
            selected_topic = TOPICS[TOPICS_STR.index(request.POST['search_topic'])]
            search_type = SEARCH_TYPES[SEARCH_TYPES_STR.index(request.POST['search_type'])]
            search_string = request.POST['search_string']
            number_of_searches = int(request.POST['number_of_searches'])

            if selected_topic != "null":
                if selected_topic == 'year' or selected_topic == 'id':
                    search_type = '__contains'
                filter = selected_topic + search_type
                all_imgs = SciamImage.objects.filter(**{filter: search_string})
                for i in range(number_of_searches):
                    selected_topic = TOPICS[TOPICS_STR.index(request.POST['search_topic_'+str(i+1)])]
                    search_type = SEARCH_TYPES[SEARCH_TYPES_STR.index(request.POST['search_type_'+str(i+1)])]
                    search_string = request.POST['search_string_'+str(i+1)]
                    if selected_topic != "null":
                        if selected_topic == 'year':
                            search_type = '__contains'
                        filter = selected_topic + search_type
                        all_imgs = SciamImage.objects.filter(**{filter: search_string})

            return Response({"data": all_imgs})

# @api_view(['GET', 'POST'])
# def sciamimage_list(request):
#     if request.method == 'GET':
#         sciamimages = SciamImage.objects.all()
#         serializer = SciamImageSerializer(sciamimages, many=True)
#         return Response(serializer.data)
#     elif request.method == 'POST':
