import csv

from sciamapp.models import SciamImage

from django.core.management.base import BaseCommand

from django.core.management.base import CommandError


class Command(BaseCommand):

    def add_arguments(self, parser):

        # get file from manage.py import <fname>
        
        parser.add_argument("fname", type = str)


    def handle(self, *arg, **options):

        with open(options["fname"], "rb") as f:

            # parse the row as a key-value dictionary

            reader = csv.DictReader(f, delimiter = ";")


            for row in reader:

                SciamImage.objects.create(

                    title = row["title"] or None,

                    image_description = row["image_description"] or None,

                    artist = row["artist"] or None,

                    article_summary = row["article_summary"] or None,

                    inventor = row["inventor"] or None,

                    author = row["author"] or None,

                    patented = row["patented"],

                    subject = row["subject"] or None,

                    subject2 = row["subject2"] or None,

                    subject3 = row["subject3"] or None,

                    keywords = row["keywords"] or None,

                    publication = row["publication"] or None,

                    date = row["date"] or None,

                    volume = int(row["volume"]) if row["volume"] else None,

                    issue = int(row["issue"]) if row["issue"] else None,

                    page = int(row["page"]) if row["page"] else None,

                    series = row["series"] or None,

                    people_involved = row["people_involved"] or None,

                    dateint = int(row["dateint"]) if row["dateint"] else None
                    
                )

