# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models
from django.contrib import admin

# Create your models here.
class SciamImage(models.Model):
    #id = models.PositiveIntegerField(primary_key=True)
    title = models.CharField(max_length=255, null=True, blank=True)
    image_description = models.TextField(null=True, blank=True)
    artist = models.CharField(max_length=255, null=True, blank=True)
    article_summary = models.TextField(null=True, blank=True)
    inventor = models.CharField(max_length=255, null=True, blank=True)
    author = models.CharField(max_length=255, null=True, blank=True)
    patented = models.CharField(max_length=255, null=True, blank=True)
    subject = models.CharField(max_length=255, null=True, blank=True)
    subject2 = models.CharField(max_length=255, null=True, blank=True)
    subject3 = models.CharField(max_length=255, null=True, blank=True)
    keywords = models.CharField(max_length=255, null=True, blank=True)
    publication = models.CharField(max_length=255, null=True, blank=True)
    date = models.DateField(null=True, blank=True)
    volume = models.PositiveIntegerField(null=True, blank=True)
    issue = models.PositiveIntegerField(null=True, blank=True)
    page = models.PositiveIntegerField(null=True, blank=True)
    series = models.CharField(max_length=255, null=True, blank=True)
    people_involved = models.CharField(max_length=255, null=True, blank=True)
    dateint = models.PositiveIntegerField(null=True, blank=True)
    url = models.URLField(max_length=300, default = "https://babel.hathitrust.org/cgi/mb?a=listsrch;q1=scientific%20american;c=1930843488;pn=1;sort=rel_d")
    #https://babel.hathitrust.org/cgi/pt?id=coo.31924080787629;view=1up;seq=412")

    def __str__(self):
        #return self.id + ':  ' + self.title + '  -  ' + self.dateint
        return '(' + str(self.id) + ')  ' + str(self.date.year) + '  :  ' + self.title

    def getYear(self):
        return self.date.year
