from django.urls import include, re_path
from . import views, list_view
from rest_framework.urlpatterns import format_suffix_patterns

urlpatterns = [
    re_path(r'^$', views.index, name='index'),
    re_path(r'^browse/', views.browse, name='browse'),
    re_path(r'^about/', views.about, name='about'),
    # url(r'^help/', views.help, name='help'),
    re_path(r'^help/', views.help, name='help'),
    re_path(r'^(?P<image_id>[0-9]+)/$', views.detail, name='detail'),
    re_path(r'^(?P<image_id_1>[0-9]+)/table/$', views.detail_table, name='detail_table'),
    re_path(r'^search/', views.search, name='search'),
    re_path(r'^search1/', views.search1, name='search1'),
    re_path(r'^search2/', views.search2, name='search2'),
    re_path(r'^under-construction/', views.under_construction, name='under_construction'),
    re_path(r'^test/', views.test, name='test'),
    re_path(r'^list/', list_view.SciamImageList.as_view()),
    re_path(r'^history/', views.history, name='history'),
]

urlpatterns = format_suffix_patterns(urlpatterns)